%define modname roomx

Summary: Issabel RoomX Module 
Name:    issabel-%{modname}
Version: 2.0
Release: 113
License: GPL
Group:   Applications/RoomX
Source0: %{modname}_%{version}-%{release}.tgz
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildArch: noarch
Prereq: issabel-framework >= 2.4,

%description
Elastix Module RoomX

%prep
%setup -n %{modname}

%install
rm -rf               $RPM_BUILD_ROOT

# Files provided by all Elastix modules
mkdir -p             $RPM_BUILD_ROOT/var/www/html/
mv modules/          $RPM_BUILD_ROOT/var/www/html/ 

# Files provided by Roomx_billing
mv roomx_billing/ 	$RPM_BUILD_ROOT/var/www/html/	

# Files provided by all Elastix Priviledged
mkdir -p             $RPM_BUILD_ROOT/usr/share/issabel/privileged
mv usr/share/issabel/privileged $RPM_BUILD_ROOT/usr/share/issabel/

# Files provided by all Elastix opt
mkdir -p             $RPM_BUILD_ROOT/opt/issabel/roomx/
mv opt/issabel/roomx/ $RPM_BUILD_ROOT/opt/issabel/

# Files provided by all Elastix init.d
mkdir -p			$RPM_BUILD_ROOT%{_sysconfdir}/init.d/
mv etc/init.d/wakeup_survey  $RPM_BUILD_ROOT%{_sysconfdir}/init.d/

# Files provided by all RoomX Sound
mkdir -p             $RPM_BUILD_ROOT/var/lib/asterisk/sounds/
mv var/lib/asterisk/sounds $RPM_BUILD_ROOT/var/lib/asterisk/

# Files provided by extensions_roomx.conf
mkdir -p    		$RPM_BUILD_ROOT%{_sysconfdir}/asterisk/
mv etc/asterisk/extensions_roomx.conf $RPM_BUILD_ROOT%{_sysconfdir}/asterisk/

# The following folder should contain all the data that is required by the installer,
# that cannot be handled by RPM.
mkdir -p    $RPM_BUILD_ROOT/usr/share/issabel/module_installer/%{name}-%{version}-%{release}/
mv setup/   $RPM_BUILD_ROOT/usr/share/issabel/module_installer/%{name}-%{version}-%{release}/
mv menu.xml $RPM_BUILD_ROOT/usr/share/issabel/module_installer/%{name}-%{version}-%{release}/

%pre
mkdir -p /usr/share/issabel/module_installer/%{name}-%{version}-%{release}/
touch /usr/share/issabel/module_installer/%{name}-%{version}-%{release}/preversion_%{modname}.info

if [ -d "/var/www/html/libs/jpgraph" ]
then
    echo "jpgraph exists"
else
    ln -s /usr/share/php/jpgraph /var/www/html/libs/jpgraph
fi

if [ $1 -eq 2 ]; then
    rpm -q --queryformat='%{VERSION}-%{RELEASE}' %{name} > /usr/share/issabel/module_installer/%{name}-%{version}-%{release}/preversion_%{modname}.info
fi

%post
pathModule="/usr/share/issabel/module_installer/%{name}-%{version}-%{release}"

# Run installer script to fix up ACLs and add module to Elastix menus.
issabel-menumerge $pathModule/menu.xml
issabel-menuremove rx_add_model

# pathSQLiteDB="/var/www/db"
# mkdir -p $pathSQLiteDB

preversion=`cat $pathModule/preversion_%{modname}.info`

MYSQL_PASSWD=`grep mysqlrootpwd= /etc/issabel.conf | sed 's/^mysqlrootpwd=//'`
if [ "$MYSQL_PASSWD" == "" ]; then
    MYSQL_PASSWD="eLaStIx.2oo7"
fi 

if [ $1 -eq 1 ]; then #install
  # The installer database
    issabel-dbprocess "install" "$pathModule/setup/db"
  # Preparing files and crontab for RoomX
    sed -i '1i#include extensions_roomx.conf\n' /etc/asterisk/extensions_custom.conf
    echo "mysql -D roomx -u root -p$MYSQL_PASSWD < /var/www/html/modules/rx_general/libs/clean.sql" > /etc/cron.daily/roomx.cron
elif [ $1 -eq 2 ]; then 
  # update
    issabel-dbprocess "update"  "$pathModule/setup/db" "$preversion"
    rm -f /etc/cron.d/roomx.cron
fi

# Install wakeup_survey as a service
chmod +x /etc/init.d/wakeup_survey
chmod +x /opt/issabel/roomx/wakeup_surveyd
chkconfig --add wakeup_survey
chkconfig --level 2345 wakeup_survey on 
service wakeup_survey start
chown root:root /usr/share/issabel/privileged/*

%clean
rm -rf $RPM_BUILD_ROOT

%preun
pathModule="/usr/share/issabel/module_installer/%{name}-%{version}-%{release}"
if [ $1 -eq 0 ] ; then # Validation for desinstall this rpm
  echo "Delete RoomX menus"
  issabel-menuremove "%{modname}"
  issabel-dbprocess "delete" "$pathModule/setup/db" 
  sed '/extensions_roomx.conf/d' /etc/asterisk/extensions_custom.conf > /tmp/roomx_tmp
  rm -f /etc/asterisk/extensions_custom.conf 
  cp /tmp/roomx_tmp /etc/asterisk/extensions_custom.conf
  chown asterisk:asterisk /etc/asterisk/extensions_custom.conf 
  rm -f /tmp/roomx_tmp
  rm -f /etc/asterisk/extensions_roomx.conf
  rm -f /etc/cron.d/roomx.cron
  rm -f /etc/cron.daily/roomx.cron
  rm -fr /var/www/html/roomx_billing
  rm -f /usr/share/issabel/privileged/vm_clean
  service wakeup_survey stop
  rm -fr /opt/issabel/roomx
  rm -f /etc/init.d/wakeup_survey 
  rm -fr /var/lib/asterisk/sounds/en/roomx
  rm -fr /var/lib/asterisk/sounds/fr/roomx
  rm -fr /var/lib/asterisk/sounds/es/roomx
  rm -fr /var/lib/asterisk/sounds/br/roomx
  if [ -d "/usr/share/php/jpgraph" ] ;	then
	cd /usr/share/php/jpgraph
	unlink /var/www/html/libs/jpgraph
  fi
  /var/lib/asterisk/bin/module_admin reload
fi

%files
%{_localstatedir}/www/html/*
%{_localstatedir}/www/html/roomx_billing/*
/usr/share/issabel/privileged/*
/usr/share/issabel/module_installer/*
/etc/init.d/wakeup_survey
/opt/issabel/roomx/*
/etc/asterisk/extensions_roomx.conf

%defattr(-, asterisk, asterisk)
%{_localstatedir}/lib/asterisk/sounds/*
%attr(777, root, root) /var/www/html/roomx_billing
%attr(777, root, root) /var/www/html/modules/rx_general/images
%attr(777, root, root) /var/www/html/modules/rx_company_rep/images
%attr(777, root, root) /var/www/html/modules/rx_booking_list/images
%attr(777, root, root) /var/www/html/modules/rx_booking_status/images
%attr(664, asterisk, asterisk) /etc/asterisk/extensions_roomx.conf

%changelog
* Sat Jul 09 2016 Franck Danard <franck.danard@it-tek.fr> 2.0-113
  - Fixed - Bad ompatibility with some themes.
  - Fixed - privileges issue for extensions_roomx.conf
  - Fixed - Twin update files having the same index for updating database. Affect the discount value. 
* Fri Jun 24 2016 Franck Danard <franck.danard@it-tek.fr> 2.0-112
  - Fixed - Speeling issue in French language.
  - Change- Discount displaying in the billing.
  - Change- Width of field room model. Now you may have up to 40 characters instead of 20.
* Sun Jun 12 2016 Franck Danard <franck.danard@it-tek.fr> 2.0-111
  - Fixed - Perissions issue on several folders. Spec file modified.
  - Fixed - "Remains to be paid" is now at zero when the billing is paid.
  - Added - "Discount" field for the rooms. Field added in general and checkout modules.
* Mon Mar 07 2016 Franck Danard <franck.danard@roomx.fr> 2.0-110
  - Fixed - duplicated function date_diff
  - Fixed - jpgraph library missing under elx 4.0, need to make a symbolic link to the new folder.
  - Added - webservice function for booking.
* Sun Nov 15 2015 Franck Danard <franck.danard@roomx.fr> 2.0-109
  - Fixed - RPM conflicts during install, some compatibility errors with Elastix 4.0.
  - Fixed - Translating issue about NIF -> TIN
  - Fixed - Syntax error into BR language into checkin module.
  -	Added - Booking number field into the database
  - Added - Webservice to make any booking 
* Sat Oct 02 2014 Franck Danard <franck.danard@roomx.fr> 2.0-108
  - Fixed - The file roomx.cron had a syntax error. 
* Sun Sep 14 2014 Franck Danard <franck.danard@roomx.fr> 2.0-107
  - Fixed - Wrong value displayed into Home menu. Just one digit displayed. 
  - Change- Now when you add or delete any rooms, Asterisk is reloaded at the end of change and not at each room.
* Wed Sep 12 2014 Franck Danard <franck.danard@roomx.fr> 2.0-106
  - Added - The table zap for Xorcom too.
* Wed Sep 12 2014 Franck Danard <franck.danard@roomx.fr> 2.0-105
  - Fixed - The logo was be displayed in a bad format again. I forgot to fix some lines too.
  - Fixed - No one Dahdi extension works with RoomX. For example, when a server includes some Xorcom modules, these extensions don't work. Asterisk database - table dahdi is not updated. 
  - Added - BR an ES languages has been fixed and/or translated by Luiz Guimaraes
* Wed May 14 2014 Franck Danard <franck.danard@roomx.fr> 2.0-102
  - Fixed - In Check out module, an echo brings up a variable content. This line has been deleted now.
  - Fixed - In Check out module, the alert message about the trunk didn't been translated.
  - Fixed - In Home page module, the alert message about the trunk didn't been translated.
  - Fixed - In the Wakeup module, the Clock is not displayed correctly using Chrome.
* Fri Apr 11 2014 Franck Danard <franck.danard@roomx.fr> 2.0-101
  - Fixed - Bad line into checkout screen. "echo $url" was here to debug this module.
  - Fixed - All buttons into every list are in the good place.
  - Fixed - Issue when no data is displayed with Booking module.
  - Fixed - Issue about CID(name) of the guest was not displayed. It was only the room name. 
  - Fixed - The condition was wrong about the checking billing capability in Home and checkout module.
  - Fixed - The called numbers don't display when no hidden digits has been selected.
  - Added - Adding NIF and official document fields into roomx database, in guest table.
  - Added - Adding NIF information into the billing.
  - Added - Adding "Payment Mode" into checkout module. This information is stored into the database.
  - Added - The informations about the dates on top of the billing are displayed now.
  - Fixed - In informations, the end date was the same than the start date.
  - Change- Checkin presentation. 
  - Change- The first VAT has been change for the fresh install. Now it's 20.0 instead of 19.6
  - Change- RoomX dial plan has been improved.
  - Change- The room list and add room are sorted by extension.
  - Change- A dialog box appears using JQuery code instead of a simple alert box into the menu : Room List.
  - Change- When you dial the clean prefix, you have a message instead a beep. 
  - Added - About Room List, a row "Wakeup" appears with a clock for each scheduled wakeup.
  - Added - Addind Spanish language (thanks at Csar A. Hernndez Arcas)
  - Added - Adding a WakeUp Module. Checking all wake up validations for each room and dialing a message to the receptionist for every missing wake up.
  - Added - An Alert message appears when there's no trunk billable to the billing rate module.
  - Added - Now, you may use the room transfer.  
* Fri Aug 17 2012 Franck Danard <franckd@agmp.org> 1.0.0-91
  - Fixed some Dahdi channels issue during check-out. The destinations was not displayed and rates too.
  - Fixed some requests from CDR database.
  - Some codes has been into home page.
  - Fixed displaying bug into company reports. When blank, a style css was displayed. 
  - Updated : Some help menu has been updated.
  - Updated : Create extensions_roomx.conf using SPEC file.
  - Adding a function to delete every voice mail at check-out.
  - Fixed the group request which displays a blank line. (Empty group) 
  - Fixed an issue during uninstall RoomX. Now all rooms will recover from-internal.
  - Fixed issue about billing, every cell has a problem with VAT. : Rounding +/- 0.01. So, some differences with the sum.
  - Fixed issue when clicking display button into check out module, the target seems to be changed with the new Elastix version : _blank instead of _next, So, the billing is displayed into a new page, Like ever.* Tue Mar 06 2012 Franck Danard <franckd@agmp.org> 0.12.25-99
  - Fixed database access for RAC module.
* Mon Feb 20 2012 Franck Danard <franckd@agmp.org> 0.12.23-98
  - Adding RAC module.
* Tue Feb 14 2012 Franck Danard <franckd@agmp.org> 0.12.22-97
  - Add the privileges on each menu.
* Wed Feb 08 2012 Franck Danard <franckd@agmp.org> 0.12.20-96
  - Merging Add model with Add model module.
  - Fixed some bugs about Dahdi channel.
